# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union
from .. import _utilities, _tables
from . import outputs
from ._inputs import *

__all__ = ['Property']


class Property(pulumi.CustomResource):
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 contacts: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 contract: Optional[pulumi.Input[str]] = None,
                 cp_code: Optional[pulumi.Input[str]] = None,
                 group: Optional[pulumi.Input[str]] = None,
                 hostnames: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 is_secure: Optional[pulumi.Input[bool]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 origins: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['PropertyOriginArgs']]]]] = None,
                 product: Optional[pulumi.Input[str]] = None,
                 rule_format: Optional[pulumi.Input[str]] = None,
                 rules: Optional[pulumi.Input[str]] = None,
                 variables: Optional[pulumi.Input[str]] = None,
                 __props__=None,
                 __name__=None,
                 __opts__=None):
        """
        The `properties.Property` resource represents an Akamai property configuration, allowing you to create,
        update, and activate properties on the Akamai platform.

        ## Example Usage
        ### Basic usage:

        ```python
        import pulumi
        import pulumi_akamai as akamai

        example = akamai.properties.Property("example",
            contacts=["user@example.org"],
            contract="ctr_####",
            cp_code="cpc_#####",
            group="grp_####",
            hostnames={
                "example.org": "example.org.edgesuite.net",
                "sub.example.org": "sub.example.org.edgesuite.net",
                "www.example.org": "example.org.edgesuite.net",
            },
            product="prd_SPM",
            rule_format="v2018-02-27",
            rules=data["local_file"]["terraform-demo"]["content"],
            variables=akamai_property_variables["origin"]["json"])
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] contacts: — (Required) One or more email addresses to inform about activation changes.
        :param pulumi.Input[str] contract: — (Optional) The contract ID.
        :param pulumi.Input[str] cp_code: — (Optional) The CP Code id or name to use (or create). Required unless a [cpCode behavior](https://developer.akamai.com/api/core_features/property_manager/vlatest.html#cpcode) is present in the default rule.
        :param pulumi.Input[str] group: — (Optional) The group ID.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] hostnames: — (Required) A map of public hostnames to edge hostnames (e.g. `{"example.org" = "example.org.edgesuite.net"}`)
        :param pulumi.Input[bool] is_secure: — (Optional) Whether the property is a secure (Enhanced TLS) property or not.
        :param pulumi.Input[str] name: — (Required) The property name.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['PropertyOriginArgs']]]] origins: — (Optional) The property origin (an origin must be specified to activate a property, but may be defined in your rules block).
        :param pulumi.Input[str] product: — (Optional) The product ID. (Default: `prd_SPM` for Ion)
        :param pulumi.Input[str] rule_format: — (Optional) The rule format to use ([more](https://developer.akamai.com/api/core_features/property_manager/v1.html#getruleformats)).
        :param pulumi.Input[str] rules: — (Required) A JSON encoded string of property rules (see: [`properties.PropertyRules`](https://www.terraform.io/docs/providers/akamai/d/property_rules.html))
        :param pulumi.Input[str] variables: — (Optional) A JSON encoded string of property manager variable definitions (see: [`properties.PropertyVariables`](https://www.terraform.io/docs/providers/akamai/r/property_variables.html))
        """
        if __name__ is not None:
            warnings.warn("explicit use of __name__ is deprecated", DeprecationWarning)
            resource_name = __name__
        if __opts__ is not None:
            warnings.warn("explicit use of __opts__ is deprecated, use 'opts' instead", DeprecationWarning)
            opts = __opts__
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = dict()

            if contacts is None:
                raise TypeError("Missing required property 'contacts'")
            __props__['contacts'] = contacts
            __props__['contract'] = contract
            __props__['cp_code'] = cp_code
            __props__['group'] = group
            if hostnames is None:
                raise TypeError("Missing required property 'hostnames'")
            __props__['hostnames'] = hostnames
            __props__['is_secure'] = is_secure
            __props__['name'] = name
            __props__['origins'] = origins
            __props__['product'] = product
            __props__['rule_format'] = rule_format
            __props__['rules'] = rules
            __props__['variables'] = variables
            __props__['account'] = None
            __props__['edge_hostnames'] = None
            __props__['production_version'] = None
            __props__['rulessha'] = None
            __props__['staging_version'] = None
            __props__['version'] = None
        super(Property, __self__).__init__(
            'akamai:properties/property:Property',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            account: Optional[pulumi.Input[str]] = None,
            contacts: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            contract: Optional[pulumi.Input[str]] = None,
            cp_code: Optional[pulumi.Input[str]] = None,
            edge_hostnames: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
            group: Optional[pulumi.Input[str]] = None,
            hostnames: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
            is_secure: Optional[pulumi.Input[bool]] = None,
            name: Optional[pulumi.Input[str]] = None,
            origins: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['PropertyOriginArgs']]]]] = None,
            product: Optional[pulumi.Input[str]] = None,
            production_version: Optional[pulumi.Input[int]] = None,
            rule_format: Optional[pulumi.Input[str]] = None,
            rules: Optional[pulumi.Input[str]] = None,
            rulessha: Optional[pulumi.Input[str]] = None,
            staging_version: Optional[pulumi.Input[int]] = None,
            variables: Optional[pulumi.Input[str]] = None,
            version: Optional[pulumi.Input[int]] = None) -> 'Property':
        """
        Get an existing Property resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] account: — the Account ID under which the property is created.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] contacts: — (Required) One or more email addresses to inform about activation changes.
        :param pulumi.Input[str] contract: — (Optional) The contract ID.
        :param pulumi.Input[str] cp_code: — (Optional) The CP Code id or name to use (or create). Required unless a [cpCode behavior](https://developer.akamai.com/api/core_features/property_manager/vlatest.html#cpcode) is present in the default rule.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] edge_hostnames: — the final public hostname to edge hostname map
        :param pulumi.Input[str] group: — (Optional) The group ID.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] hostnames: — (Required) A map of public hostnames to edge hostnames (e.g. `{"example.org" = "example.org.edgesuite.net"}`)
        :param pulumi.Input[bool] is_secure: — (Optional) Whether the property is a secure (Enhanced TLS) property or not.
        :param pulumi.Input[str] name: — (Required) The property name.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['PropertyOriginArgs']]]] origins: — (Optional) The property origin (an origin must be specified to activate a property, but may be defined in your rules block).
        :param pulumi.Input[str] product: — (Optional) The product ID. (Default: `prd_SPM` for Ion)
        :param pulumi.Input[int] production_version: — the current version of the property active on the production network.
        :param pulumi.Input[str] rule_format: — (Optional) The rule format to use ([more](https://developer.akamai.com/api/core_features/property_manager/v1.html#getruleformats)).
        :param pulumi.Input[str] rules: — (Required) A JSON encoded string of property rules (see: [`properties.PropertyRules`](https://www.terraform.io/docs/providers/akamai/d/property_rules.html))
        :param pulumi.Input[int] staging_version: — the current version of the property active on the staging network.
        :param pulumi.Input[str] variables: — (Optional) A JSON encoded string of property manager variable definitions (see: [`properties.PropertyVariables`](https://www.terraform.io/docs/providers/akamai/r/property_variables.html))
        :param pulumi.Input[int] version: — the current version of the property config.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = dict()

        __props__["account"] = account
        __props__["contacts"] = contacts
        __props__["contract"] = contract
        __props__["cp_code"] = cp_code
        __props__["edge_hostnames"] = edge_hostnames
        __props__["group"] = group
        __props__["hostnames"] = hostnames
        __props__["is_secure"] = is_secure
        __props__["name"] = name
        __props__["origins"] = origins
        __props__["product"] = product
        __props__["production_version"] = production_version
        __props__["rule_format"] = rule_format
        __props__["rules"] = rules
        __props__["rulessha"] = rulessha
        __props__["staging_version"] = staging_version
        __props__["variables"] = variables
        __props__["version"] = version
        return Property(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def account(self) -> pulumi.Output[str]:
        """
        — the Account ID under which the property is created.
        """
        return pulumi.get(self, "account")

    @property
    @pulumi.getter
    def contacts(self) -> pulumi.Output[Sequence[str]]:
        """
        — (Required) One or more email addresses to inform about activation changes.
        """
        return pulumi.get(self, "contacts")

    @property
    @pulumi.getter
    def contract(self) -> pulumi.Output[Optional[str]]:
        """
        — (Optional) The contract ID.
        """
        return pulumi.get(self, "contract")

    @property
    @pulumi.getter(name="cpCode")
    def cp_code(self) -> pulumi.Output[Optional[str]]:
        """
        — (Optional) The CP Code id or name to use (or create). Required unless a [cpCode behavior](https://developer.akamai.com/api/core_features/property_manager/vlatest.html#cpcode) is present in the default rule.
        """
        return pulumi.get(self, "cp_code")

    @property
    @pulumi.getter(name="edgeHostnames")
    def edge_hostnames(self) -> pulumi.Output[Mapping[str, str]]:
        """
        — the final public hostname to edge hostname map
        """
        return pulumi.get(self, "edge_hostnames")

    @property
    @pulumi.getter
    def group(self) -> pulumi.Output[Optional[str]]:
        """
        — (Optional) The group ID.
        """
        return pulumi.get(self, "group")

    @property
    @pulumi.getter
    def hostnames(self) -> pulumi.Output[Mapping[str, str]]:
        """
        — (Required) A map of public hostnames to edge hostnames (e.g. `{"example.org" = "example.org.edgesuite.net"}`)
        """
        return pulumi.get(self, "hostnames")

    @property
    @pulumi.getter(name="isSecure")
    def is_secure(self) -> pulumi.Output[Optional[bool]]:
        """
        — (Optional) Whether the property is a secure (Enhanced TLS) property or not.
        """
        return pulumi.get(self, "is_secure")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        — (Required) The property name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def origins(self) -> pulumi.Output[Optional[Sequence['outputs.PropertyOrigin']]]:
        """
        — (Optional) The property origin (an origin must be specified to activate a property, but may be defined in your rules block).
        """
        return pulumi.get(self, "origins")

    @property
    @pulumi.getter
    def product(self) -> pulumi.Output[Optional[str]]:
        """
        — (Optional) The product ID. (Default: `prd_SPM` for Ion)
        """
        return pulumi.get(self, "product")

    @property
    @pulumi.getter(name="productionVersion")
    def production_version(self) -> pulumi.Output[int]:
        """
        — the current version of the property active on the production network.
        """
        return pulumi.get(self, "production_version")

    @property
    @pulumi.getter(name="ruleFormat")
    def rule_format(self) -> pulumi.Output[Optional[str]]:
        """
        — (Optional) The rule format to use ([more](https://developer.akamai.com/api/core_features/property_manager/v1.html#getruleformats)).
        """
        return pulumi.get(self, "rule_format")

    @property
    @pulumi.getter
    def rules(self) -> pulumi.Output[Optional[str]]:
        """
        — (Required) A JSON encoded string of property rules (see: [`properties.PropertyRules`](https://www.terraform.io/docs/providers/akamai/d/property_rules.html))
        """
        return pulumi.get(self, "rules")

    @property
    @pulumi.getter
    def rulessha(self) -> pulumi.Output[str]:
        return pulumi.get(self, "rulessha")

    @property
    @pulumi.getter(name="stagingVersion")
    def staging_version(self) -> pulumi.Output[int]:
        """
        — the current version of the property active on the staging network.
        """
        return pulumi.get(self, "staging_version")

    @property
    @pulumi.getter
    def variables(self) -> pulumi.Output[Optional[str]]:
        """
        — (Optional) A JSON encoded string of property manager variable definitions (see: [`properties.PropertyVariables`](https://www.terraform.io/docs/providers/akamai/r/property_variables.html))
        """
        return pulumi.get(self, "variables")

    @property
    @pulumi.getter
    def version(self) -> pulumi.Output[int]:
        """
        — the current version of the property config.
        """
        return pulumi.get(self, "version")

    def translate_output_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return _tables.SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

